Page MenuHomePhabricator

Adding watch option or watch by default using upload wizard
Closed, ResolvedPublic

Description

On Commons (https://commons.wikimedia.org/wiki/Commons:Forum#Einstellungen_bei_Neulingen) there was the request that it would be great to have an option to watch the new file, which is ticked by default to make new users see what is happening with their files or just watch by default. Unwatching is easy so this should not be very controversial.

Add something to http://svn.mediawiki.org/viewvc/mediawiki/trunk/extensions/UploadWizard/resources/mw.ApiUploadHandler.js ? E.g.

_this.addFormInputIfMissing( 'watchlist', 'watch' );

If there are no objections, a patch will follow.


Version: unspecified
Severity: enhancement

Details

Reference
bz31313

Event Timeline

bzimport raised the priority of this task from to Low.
bzimport set Reference to bz31313.
Rillke created this task.Oct 2 2011, 5:51 PM

True to the previous comment, since there were no objections, the patch is here: https://gerrit.wikimedia.org/r/10347

Adding watch=1 to the initial stash upload does absolutely nothing (because you would be watching a stashed file), but adding the parameter to the final upload action was a good way to accomplish this.

Adding a checkbox might be a little bit extra, but it's possible.

New users who have no Wikimedia experience will not have any understanding what "Watch this file" means or how to meaningfully derive any value from this feature. We should:

  • pick sensible defaults
  • make defaults customizable through preferences
  • avoid complicating the UI with options that only overwhelm, not help, new users.

If it's usually sensible to watch every upload, we can make this the default for new users, and a preference for all users.

Is there really a use case for offering this option on a per-file basis? How common is the case that you'll want to un-select a specific file, and is it not adequately served by un-watching it after your upload?

I posted in [[COM:VP]] about this, but didn't seem to get any answers.

My understanding is, in order:

  • It makes sense to auto-watch any files you upload, since you have at least some connection to them
  • Preferences sound good, that shouldn't be too difficult to add
  • "Watch this file" isn't all that complicated, but we could change it to something like "Notify me when this file or its details are modified" to help out new users

While it might be adequate to manually un-watch one file or two, the whole point of UW is to allow this intersection of batch and fine-grained detail. Yes, if you want, we'll do all the same stuff for every file, but you can change it afterwards. So, we could add this into the copyMetaData functionality and leave it as an option. I don't really see it making too much trouble.

I'll start with the preferences idea, then come back to evaluate the copyMetaData option.

All right, the user preference is up, and I've changed the wording of the i18n message for auto-watch.

Now on to the question: Should we allow an intermediate level of control (between "every file of every batch" and "this file") by including auto-watch in the copyMetaData section? This would allow a user to watch (or not watch) a single batch, without having to click on each file. If this is deemed a useful feature, I can add it easily.

Any additional per-file checkbox or option adds complexity, reduces scannability, and increases the risk of the user being confused or frustrated. An elegantly designed application should reduce the exposure of options that are infrequently used. So far I'm not seeing any evidence that "watch this file" is frequently enough used on a _per-file_ basis to warrant inclusion at that level; that includes any copyMetadata implementation.

So, in other words, I would get rid of the per-file checkbox, and evaluate the value of the user pref on upload.

Well....is it even worth it, then, to include the option in UW? Maybe this is adequately served by the existing "Add pages I (create|edit|move) to my watchlist" in Preferences > Watchlist? I mean, the UW preference would allow you to only watch uploaded files, but maybe what we're approaching is an additional preference in core that allows users to watch pages they create in the file namespace, or maybe any arbitrary namespace, rather than something we throw on the tail end of UploadWizard.

Rillke, could you comment on whether a user preference would fulfill your needs?

Yes, on closer inspection, I'm not seeing the need for even an additional preference. The existing watchlist preference for watching created pages already operates in this manner. It would be useful to update the message text in core to clarify that it refers to files as well, not just pages.

I'm seeing now that this option is specifically disabled for Commons and enabled everywhere else:

if( $wgDBname != 'commonswiki' ) {
$wgDefaultUserOptions['watchcreations'] = 1;
}

http://noc.wikimedia.org/conf/CommonSettings.php.txt

So at some point someone seems to have decided that flooding the watchlist of every user with every uploaded file would be too spammy. This request would effectively accomplish the opposite. We should make sure there's consensus to do so before we change it.

By default, Commons has it disabled, but the option is still available--agreed, though, we should ensure that it's easy enough to find.

In case the original reporter wants something a little more flexible, my patch is still available, but now I'll whip up an i18n change for core to better explain the auto-watch options.

Think of the various upload bots running on Commons. They surely don't need a watchlist but they also don't upload with UploadWizard.

If these criteria are met, I am happy:

  • New users watch their new uploads by default.
  • A (default) option specifically for uploads whether to watch or not to watch their uploaded files. (Not really important whether this is a general option or one for UpWiz only since UpWiz is the default)

Patch here: https://gerrit.wikimedia.org/r/11054

But it sounds like we might need to add in preferences to core in order to satisfy the above requirements, since this current set of preferences are for all pages, not just files.

Better patch: https://gerrit.wikimedia.org/r/11063

Hopefully that will cover everyone's interest in this bug, if not, please let me know so I can fix it!

(In reply to comment #8)

It would be useful to update the message text
in core to clarify that it refers to files as well, not just pages.

The Upload message (Tog-watchcreations), OK. But Tog-watchmoves? Tog-watchdeletion?? Tog-enotifwatchlistpages??? Tog-enotifminoredits????

Should we also clarify that it refers as well to templates, portals, community discussions, whatever? I appreciate the upload is quite a different operation than a page edit, especially given the Upload Wizard interface and its lack of explicit “ “watch this” checkbox (the preference has always been only about a default value, but OK).

However, moving, editing, and deletion of a file looks and behaves the same way like moving, editing and deletion of any other page, with the explicit “watch this” checkbox, and there is no reason to explicitly mention files there. And what exactly are “minor edits of files”, I have no idea at all.

Bug assigned to code submitter.

Patch in Gerrit needs rework.

mtraceur, do you plan to work on this? If not, feel free to reset assignee and status of this bug report. Thanks!

Because James_F whined to me in person, I'll take another crack at this.

Change 11063 had a related patch set uploaded by MarkTraceur:
Add preference for watching uploaded files

https://gerrit.wikimedia.org/r/11063

Still waiting on code review.

Jdforrester-WMF moved this task from Untriaged to Doing on the Multimedia board.Apr 30 2015, 4:08 PM

Change 11063 had a related patch set uploaded (by Jforrester):
Add preference for watching uploaded files

https://gerrit.wikimedia.org/r/11063

Restricted Application added subscribers: Steinsplitter, Matanya, Aklapper. · View Herald TranscriptAug 27 2015, 3:56 PM
Jdforrester-WMF closed this task as Resolved.Apr 12 2016, 5:18 PM
Jdforrester-WMF edited projects, added User-notice; removed Patch-For-Review.
Jdforrester-WMF set Security to None.

Change 11063 merged by jenkins-bot:
Add preference for watching uploaded files

https://gerrit.wikimedia.org/r/11063

Johan added a subscriber: Johan.Apr 14 2016, 5:43 PM

This will be in next week's Tech News, as there's no MediaWiki version this week.